PROGRAM Change_Directory;

TYPE
  regpack    = RECORD
                 CASE BOOLEAN OF
                 TRUE:  (ax, bx, cx, dx, bp, si, di, ds, es, flags: INTEGER);
                 FALSE: (al, ah, bl, bh, cl, ch, dl, dh: BYTE);
               END;
  String8    = String [8];
  String13   = String [13];
  String255  = String [255];
  ASCIIZ     = ARRAY [1..255] OF CHAR;


VAR
  Ch           : CHAR;
  Regs         : regpack;
  Entry, Loc,
  Old_Loc      : INTEGER;
  Current_Disk : BYTE;
  Possible_Dir : ARRAY [1..80] OF String13;
  Current_Path : String255;


FUNCTION TestBit (B : BYTE; BitNo : INTEGER) : BOOLEAN;
BEGIN
  TestBit := FALSE;
  CASE BitNo OF
    0: IF B AND   1 > 0 THEN TestBit := TRUE;
    1: IF B AND   2 > 0 THEN TestBit := TRUE;
    2: IF B AND   4 > 0 THEN TestBit := TRUE;
    3: IF B AND   8 > 0 THEN TestBit := TRUE;
    4: IF B AND  16 > 0 THEN TestBit := TRUE;
    5: IF B AND  32 > 0 THEN TestBit := TRUE;
    6: IF B AND  64 > 0 THEN TestBit := TRUE;
    7: IF B AND 128 > 0 THEN TestBit := TRUE;
    ELSE;
    END
END;

PROCEDURE XDir (Drive : BYTE);

CONST
  Offset = 5;

VAR
  Regs      : regpack;
  DTA       : ARRAY [1..44] OF BYTE;
  Search    : ARRAY [1..7] OF BYTE;
  LongName  : String13;
  FileName  : String8;
  FileExt   : String8;
  Attribute : String8;
  i, j      : INTEGER;

BEGIN
  FillChar (DTA, 44, 0);
  WITH Regs DO BEGIN
    AX := $1A00;
    DS := Seg (DTA);
    DX := Ofs (DTA)
  END;
  MsDos (Regs);

  Search [1] := Drive + 64;
  Search [2] := ORD (':');
  Search [3] := ORD ('*');
  Search [4] := ORD ('.');
  Search [5] := ORD ('*');
  Search [6] := 0;

  WITH Regs DO BEGIN
    AX := $4E00;
    DS := Seg (Search);
    DX := Ofs (Search);
    CX := $16
  END;
  MsDos (Regs);

  WHILE Regs.AL = 0 DO BEGIN
    LongName [0] := CHR (13);
    MOVE (DTA[31], LongName [1], 13);
    FileName := ''; i := 1;
    WHILE (i <= 8) AND (LongName[i] <> CHR (0)) AND (LongName[i] <> '.') DO
    BEGIN
      FileName := FileName + LongName[i];
      i := i + 1
    END;
    FileExt := '';
    IF LongName[i] = '.' THEN BEGIN
      j := i;
      i := 1;
      WHILE (i <= 3) DO BEGIN
        FileExt := FileExt + LongName [i+j];
        i := i + 1
      END
    END;
    IF TestBit (DTA [22],4) THEN BEGIN
       (* This is a directory entry *)
       IF FileName <> '.' THEN BEGIN
          IF FileName = '..' THEN FileName := '.. (upper dir)';
          IF FileExt = '' THEN Possible_Dir [Entry] := FileName
               ELSE Possible_Dir [Entry] := FileName + '.' + FileExt;
          Entry := Entry + 1
       END
    END;

    FOR i := 31 TO 43 DO DTA [i] := 32;
    Regs.AX := $4F00;
    MsDos (Regs)
  END
END;


PROCEDURE Get_Current_Path (Drive : BYTE; VAR Act_Path : String255);

VAR
  Regs  : regpack;
  Temp  : ASCIIZ;
  i     : INTEGER;

BEGIN
  Regs.DX := Drive;
  Regs.DS := Seg (Temp);
  Regs.SI := Ofs (Temp);
  Regs.AX := $4700;
  MsDos (Regs);

  Act_Path := '\';
  i := 1;
  WHILE (Temp [i] <> CHR (0)) AND  (i <= 255) DO BEGIN
      Act_Path := Act_Path + Temp [i];
      i := i + 1
  END
END (* Get_Current_Path *);


PROCEDURE WriteSubDirs (Num : INTEGER);
VAR i,j : INTEGER;
BEGIN
  ClrScr;
  i := Current_Disk + 64;
  WRITELN (' Current directory&path ', CHR (i), ':', Current_Path);
  WRITELN ('');
  WRITELN (' Select in the following list of subdirectories by moving around');
  WRITELN (' with the cursor keys, and changing to a highlighted item by');
  WRITELN (' pressing the <ENTER> key. The <Esc> key stops the program.');

  FOR i := 1 TO Num DO BEGIN
    GotoXY (5 + 18*((i-1) MOD 4), 7+((i-1) DIV 4));
    WRITE  (Possible_Dir [i])
  END;
  GotoXY (5, 7);
  TextBackground (White); TextColor (Black);
  WRITE  (Possible_Dir [1]);
  TextBackground (Black); TextColor (White);

END {WriteSubDirs};


PROCEDURE Update_Cursor;
BEGIN
  GotoXY (5 + 18*((Old_Loc-1) MOD 4), 7+((Old_Loc-1) DIV 4));
  TextBackground (Black); TextColor (White);
  WRITE  (Possible_Dir [Old_Loc]);

  GotoXY (5 + 18*((Loc-1) MOD 4), 7+((Loc-1) DIV 4));
  TextBackground (White); TextColor (Black);
  WRITE  (Possible_Dir [Loc]);
  TextBackground (Black); TextColor (White);
END;

BEGIN
  WITH Regs DO BEGIN
    ax := $1900;
    MsDos (Regs);
    Current_Disk := SUCC (ax AND $FF)
  END;

  Get_Current_Path (Current_Disk, Current_Path);

  Entry := 1;
  XDir (Current_Disk);

  TextMode (C80);
  WriteSubDirs (Entry-1);
  Loc := 1;

  repeat
    repeat read(Kbd,Ch) until Ch in [#27,#13];
    case Upcase(Ch) of
      #13: (* Just do nothing *);
      #27: begin
             read(Kbd,Ch);
             Old_Loc := Loc;
             case Ch of
               'H': begin  (* Up Arrow *)
                      IF Loc > 4 THEN Loc := Loc - 4
                    end;
               'K': begin  (* Left Arrow *)
                      IF Loc > 1 THEN Loc := Loc - 1
                    end;
               'M': begin  (* Right Arrow *)
                      IF Loc < (Entry-1) THEN Loc := Loc + 1
                    end;
               'P': begin  (* Down Arrow *)
                      IF Loc <= (Entry-5) THEN Loc := Loc + 4
                    end;
             end;
             Update_Cursor;
       end
    end;
  UNTIL Ch IN [#27, #13];
  {$I-} IF Ch = #13 THEN ChDir (Possible_Dir [Loc]); {$I+}
  ClrScr

END.
